import 'package:example/employee/employee.controller.dart';
import 'package:flutter/material.dart';
import 'package:tecfy_basic_package/tecfy_basic_package.dart';

class EmployeePage extends StatefulWidget {
  const EmployeePage({Key? key}) : super(key: key);

  @override
  _EmployeePageState createState() => _EmployeePageState();
}

class _EmployeePageState extends AppState<EmployeePage, EmployeeController> {
  @override
  EmployeeController createController() => EmployeeController(this);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('Employees')),
      floatingActionButton: FloatingActionButton(
        child: Text('Add Employee'),
        onPressed: controller.addEmployee,
        isExtended: true,
      ),
      body: ValueListenableBuilder(
          valueListenable: controller.length,
          builder: (c, s, d) => ListView.builder(
                itemCount: controller.employees.length,
                itemBuilder: (c, i) => ListTile(
                  title: Text(controller.employees[i].displayName),
                  trailing: Text(controller.employees[i].id),
                ),
              )),
    );
  }
}
